uses
  testlib, SysUtils;
const
  types = 'WBC';
var
  n, i, k, p : integer;
  ps, js : string;
  a : array[1..3] of integer;
begin
  n := inf.readlongint;
  for i := 1 to 3 do begin
    a[i] := inf.readlongint;
  end;
  k := inf.readlongint;
  ps := ouf.readword(blanks, blanks);
  js := ans.readword(blanks, blanks);
  if (ps <> 'YES') and (ps <> 'NO') then
    quit(_pe, '''YES'' or ''NO'' expected, ' + ps + ' found');
  if (ps = 'NO') then begin
    if (js = 'NO') then
      quit(_ok, 'No solution');
    quit(_wa, 'Solution not found');
  end;
  ps := ouf.readword(blanks, blanks);
  if (length(ps) <> n) then 
    quit(_pe, 'Wrong length of answer - expected: ' + IntToStr(n) + ', found: ' + IntToStr(length(ps)));
  for i := 1 to n do begin
    p := pos(ps[i], types);
    if (p = 0) then
      quit(_pe, 'Wrong color of tshirt: ' + ps[i]);
    if (i > 1) and (ps[i] = ps[i - 1]) then
      quit(_wa, 'Equal colors of two consecutive day''s');
    if (i > 7) and (ps[i] = ps[i - 7]) then
      quit(_wa, 'Equal colors of two consecutive weekday''s');
    if (a[p] = 0) then
      quit(_wa, 'No more tshirts of color: ' + ps[i]);
    if (a[p] < k) then begin
      a[p] := a[p] - 1;
    end;
  end;
  if (js = 'NO') then
    quit(_fail, 'Contestant found better solution');
  quit(_ok, 'OK');
end.